       program Machines
       include 'param.inc'
       integer icores(nmax),nnames,nlen(nmax)
       character*20 names(nmax)
       CHARACTER*180     DEFFN, ERRFN,FNAME
       CHARACTER*11     STATUS,FORM
       logical there
       character*4 nmode
!
!      Input
!      Unit  9, options file (e.g. case.inmachines)
!      Set by x at the moment (could be changed)
!      Unit 10, machines file from PBS or other queue
!      Unit 20, framework (to be described below)
!
!      Output
!      Unit 21, .machines file (opened in code)
!
!      The framework is simple
!      For lapw1, lines such as 1: 64
!      are interpreted to mean 1 k-point, 64 cpu's
!      For lapw0, lines such as lapw0: 64
!      are similarly interpreted
!      anything else is copied over.
!
!      Therefore a conventional machines file such as
!         extrafine
!         2: node1:2 node2:2
!         3: node4:2 node5:2
!         lapw0: node1:2 node2:2 node4:2
!
!      Would be entered as
!         extrafine
!         2: 4
!         2: 4
!         lapw0: 6
!
!      Assuming in PBS mode a list with (one line for each entry) of
!      node1 node1 node2 node2 node4 node4 node5 node5
!
!      Warning: the user has to get the breakdown correct and in the right order
!      Might not always work...
!
       nmode='PBSL'
!
      CALL GTFNAM(DEFFN,ERRFN)
      CALL ERRFLG(ERRFN,'Error in Machines')
!
!     Standard opens
      OPEN(1,FILE=DEFFN,STATUS='OLD',ERR=8000)
 8003 READ(1,*,END=8001) IUNIT,FNAME,STATUS,FORM,IRECL
      OPEN(IUNIT,FILE=FNAME,STATUS=STATUS,FORM=FORM, &
         ERR=8002)
      if(debug)write(*,*)'Unit ',iunit,'File ',fname
      GOTO 8003
 8000 WRITE(*,*) ' ERROR IN OPENING Machines.DEF !!!!'
      STOP 'Machines.DEF'
 8002 WRITE(*,*) ' ERROR IN OPENING UNIT:',IUNIT
      WRITE(*,*) '       FILENAME: ',FNAME,'  STATUS: ',STATUS, &
      '  FORM:',FORM
      STOP 'OPEN FAILED'
 8001 CONTINUE

!      Options
       read(9,10,err=20,end=20)form
       if(form(1:3) .eq. 'SGI' )then
        nmode='SGIM'
!      else if (form(1:3) .eq. XXX )then
!       Add here and below
!
       endif

10     format(a)
20     continue
!      What format is the list of nodes in?
       if(nmode .eq. 'XXX' )then
!               Add here subroutines for other formats?
       else if(nmode .eq. 'SGIM')then
                call ReadSGIlist(names,icores,nnames,nlen)
                write(6,10)'Using an input SGI format'
       else
!               Default
                call ReadPBSlist(names,icores,nnames,nlen)
                write(6,10)'Using 1 line per mpirun process'
       endif
!
!      Check if .machines_frame is present
!      If not, write a default 1 k-pt type file
       call CheckMachines(there,names,icores,nnames,nlen)
!
!      If default, go to cleanup
       if(.not.there)goto 1000
!
!      write a Wien2k style file using .machines_frame
       call WriteMachines(names,icores,nnames,nlen)
!      Done

1000   continue
!      Cleanup (do later)
       CALL errclr(errfn)
       stop
!      Errors...
       end
